summaryrefslogtreecommitdiff
path: root/dselect/methods
diff options
context:
space:
mode:
authorGuillem Jover <guillem@debian.org>2006-02-17 02:34:25 +0000
committerGuillem Jover <guillem@debian.org>2006-02-17 02:34:25 +0000
commit00959fb95f66873087420a0afd79a0f36ab5bc2a (patch)
treeadfe1af9e1dbe1b41c8d49a7bfd4e7222fb73a11 /dselect/methods
parent753c4f8b99faee9311d7028012980a3f8b89bfa8 (diff)
downloaddpkg-00959fb95f66873087420a0afd79a0f36ab5bc2a.tar.gz
Move the methods directory to dselect/methods, so the contents will not
be installed if dselect is not to be built.
Diffstat (limited to 'dselect/methods')
-rw-r--r--dselect/methods/Makefile.am26
-rw-r--r--dselect/methods/disk/desc.cdrom3
-rw-r--r--dselect/methods/disk/desc.harddisk9
-rw-r--r--dselect/methods/disk/desc.mounted12
-rw-r--r--dselect/methods/disk/desc.nfs9
-rwxr-xr-xdselect/methods/disk/install121
-rw-r--r--dselect/methods/disk/names4
-rwxr-xr-xdselect/methods/disk/setup574
-rwxr-xr-xdselect/methods/disk/update92
-rw-r--r--dselect/methods/floppy/desc.floppy9
-rwxr-xr-xdselect/methods/floppy/install100
-rw-r--r--dselect/methods/floppy/names1
-rwxr-xr-xdselect/methods/floppy/setup76
-rwxr-xr-xdselect/methods/floppy/update76
14 files changed, 1112 insertions, 0 deletions
diff --git a/dselect/methods/Makefile.am b/dselect/methods/Makefile.am
new file mode 100644
index 000000000..0542069e8
--- /dev/null
+++ b/dselect/methods/Makefile.am
@@ -0,0 +1,26 @@
+## Process this file with automake to produce Makefile.in
+
+methodsdir = $(pkglibdir)/methods
+
+nobase_dist_methods_DATA = \
+ disk/names \
+ disk/desc.cdrom \
+ disk/desc.nfs \
+ disk/desc.harddisk \
+ disk/desc.mounted \
+ floppy/names \
+ floppy/desc.floppy
+
+nobase_dist_methods_SCRIPTS = \
+ disk/setup \
+ disk/update \
+ disk/install \
+ floppy/setup \
+ floppy/update \
+ floppy/install
+
+
+install-data-local:
+ $(mkdir_p) $(DESTDIR)$(admindir)/methods/mnt
+ $(mkdir_p) $(DESTDIR)$(admindir)/methods/disk
+ $(mkdir_p) $(DESTDIR)$(admindir)/methods/floppy
diff --git a/dselect/methods/disk/desc.cdrom b/dselect/methods/disk/desc.cdrom
new file mode 100644
index 000000000..b400abb04
--- /dev/null
+++ b/dselect/methods/disk/desc.cdrom
@@ -0,0 +1,3 @@
+Installation from a CD-ROM containing a Debian distribution. The
+CD-ROM may be or not be mounted already; it should contain a standard
+ISO9660 CD-ROM filesystem.
diff --git a/dselect/methods/disk/desc.harddisk b/dselect/methods/disk/desc.harddisk
new file mode 100644
index 000000000..ba4575030
--- /dev/null
+++ b/dselect/methods/disk/desc.harddisk
@@ -0,0 +1,9 @@
+Installation from filesystem on a hard disk partition that's not
+currently mounted.
+
+The partition should contain the Packages.gz file from each
+distribution area being installed (usually stable, contrib and
+non-free) as well as the corresponding binary/*/*.deb files.
+
+The easiest way to get this is to make a (partial) copy of the
+distribution site's directory hierarchy, if possible.
diff --git a/dselect/methods/disk/desc.mounted b/dselect/methods/disk/desc.mounted
new file mode 100644
index 000000000..b980d70ae
--- /dev/null
+++ b/dselect/methods/disk/desc.mounted
@@ -0,0 +1,12 @@
+Installation from a directory on a filesystem that has already been
+mounted. If the options available for mounting things automatically
+are inadequate for your needs you'll need to get a shell command
+prompt (for example by switching VT using Alt-F<n> or quitting
+dselect) and use it to mount the filesystem before continuing.
+
+The area you're installing from should contain the Packages.gz file
+from each distribution area being installed (usually stable, contrib
+and non-free) as well as the corresponding binary/*/*.deb files.
+
+The easiest way to do get this is to make a (partial) copy of the
+distribution site's directory hierarchy, if possible.
diff --git a/dselect/methods/disk/desc.nfs b/dselect/methods/disk/desc.nfs
new file mode 100644
index 000000000..77bb64082
--- /dev/null
+++ b/dselect/methods/disk/desc.nfs
@@ -0,0 +1,9 @@
+Installation across the network, from an NFS server which not
+currently mounted.
+
+The server should have contain the Packages.gz file from each
+distribution area being installed (usually stable, contrib and
+non-free) as well as the corresponding binary/*/*.deb files.
+
+The easiest way for them to get this is to make a (partial) copy of
+the distribution site's directory hierarchy, if possible.
diff --git a/dselect/methods/disk/install b/dselect/methods/disk/install
new file mode 100755
index 000000000..868c64a6b
--- /dev/null
+++ b/dselect/methods/disk/install
@@ -0,0 +1,121 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/disk"
+
+. ./shvar.$option
+
+xit=1
+trap '
+ if [ -n "$umount" ]
+ then
+ umount "$umount" >/dev/null 2>&1
+ fi
+ exit $xit
+' 0
+
+if [ -n "$p_blockdev" ]
+then
+ umount="$p_mountpoint"
+ mount -rt "$p_fstype" -o nosuid,nodev "$p_blockdev" "$p_mountpoint"
+fi
+
+if [ -n "$p_nfs" ]
+then
+ umount="$p_mountpoint"
+ mount -rt nfs "$p_nfs" -o nosuid,nodev "$p_mountpoint"
+fi
+
+predep="$vardir/predep-package"
+while true
+do
+ set +e
+ dpkg --admindir "$vardir" --predep-package >"$predep"
+ rc=$?
+ set -e
+ if test $rc = 1; then break; fi
+ test $rc = 0
+
+ perl -e '
+ ($binaryprefix,$predep) = @ARGV;
+ $binaryprefix =~ s,/*$,/, if length($binaryprefix);
+ open(P,"< $predep") || die "cannot open $predep: $!\n";
+ while (<P>) {
+ s/\s*\n$//;
+ $package= $_ if s/^Package: //i;
+ @filename= split(/ /,$_) if s/^Filename: //i;
+ @msdosfilename= split(/ /,$_) if s/^MSDOS-Filename: //i;
+ }
+ length($package) || die "internal error - no package";
+ @filename || die "internal error - no filename";
+ @filename==@msdosfilename || !@filename || !@msdosfilename ||
+ die "internal error - mismatch >@filename< >@msdosfilename<";
+ @invoke=(); $|=1;
+ for ($i=0; $i<=$#filename; $i++) {
+ $ppart= $i+1;
+ print "Looking for part $ppart of $package ... ";
+ if (-f "$binaryprefix$filename[$i]") {
+ $print= $filename[$i];
+ $invoke= "$binaryprefix$filename[$i]";
+ } elsif (-f "$binaryprefix$msdosfilename[$i]") {
+ $print= $msdosfilename[$i];
+ $invoke= "$binaryprefix$msdosfilename[$i]";
+ } else {
+ $base= $filename[$i]; $base =~ s,.*/,,;
+ $msdosbase= $msdosfilename[$i]; $msdosbase =~ s,.*/,,;
+ defined($c= open(X,"-|")) ||
+ die "failed to fork for find: $!\n";
+ if (!$c) {
+ exec("find", length($binaryprefix)
+ ? $binaryprefix : ".","-follow",
+ "-name",$base,"-o","-name",$msdosbase);
+ die "failed to exec find: $!\n";
+ }
+ while (chop($invoke= <X>)) { last if -f $invoke; }
+ $print= $invoke;
+ if (substr($print,0,length($binaryprefix)+1) eq
+ "$binaryprefix/") {
+ $print= substr($print,length($binaryprefix));
+ }
+ }
+ if (!length($invoke)) {
+ print STDERR "
+
+Oh dear, I need to install or upgrade $package, but I don'\''t see
+the appropriate file(s) anywhere. I'\''m expecting version $version or
+later, as that is listed in the Packages file.
+
+Perhaps you downloaded it with an unexpected name, or something.
+In any case, you must find the file(s) and then either place it with
+the correct filename(s) (as listed in the Packages file or in
+$vardir/available) and rerun the installation, or upgrade the
+package by using `dpkg --install --auto-deconfigure'\'' by hand.
+
+";
+ exit(1);
+ }
+ print "$print\n";
+ push(@invoke,$invoke);
+ }
+ print "Running dpkg -iB for $package ...\n";
+ exec("dpkg","--admindir",$vardir,"-iB","--",@invoke);
+ die "failed to exec dpkg: $!\n";
+ ' -- "$p_mountpoint$p_main_binary" "$predep"
+done
+
+for f in main ctb nf nus lcl
+do
+ eval 'this_binary=$p_'$f'_binary'
+ if [ -z "$this_binary" ]; then continue; fi
+ echo Running dpkg --admindir $vardir -iGROEB "$p_mountpoint$this_binary"
+ dpkg --admindir $vardir -iGROEB "$p_mountpoint$this_binary"
+done
+
+echo -n 'Installation OK. Hit RETURN. '
+read response
+
+xit=0
diff --git a/dselect/methods/disk/names b/dselect/methods/disk/names
new file mode 100644
index 000000000..1f55b78e3
--- /dev/null
+++ b/dselect/methods/disk/names
@@ -0,0 +1,4 @@
+30 cdrom Install from a CD-ROM.
+35 nfs Install from an NFS server (not yet mounted).
+40 harddisk Install from a hard disk partition (not yet mounted).
+42 mounted Install from a filesystem which is already mounted.
diff --git a/dselect/methods/disk/setup b/dselect/methods/disk/setup
new file mode 100755
index 000000000..be3b5650a
--- /dev/null
+++ b/dselect/methods/disk/setup
@@ -0,0 +1,574 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/disk"
+tp=/var/run/ddm$$
+
+iarch=`dpkg --admindir $vardir --print-architecture`
+
+xit=1
+trap '
+ rm -f $tp.?
+ if [ -n "$umount" ]
+ then
+ umount "$umount" >/dev/null 2>&1
+ fi
+ exit $xit
+' 0
+
+if ls -d "$tp.?" >/dev/null 2>&1
+then
+ rm $tp.?
+fi
+
+yesno () {
+ while true
+ do
+ echo -n "$2 [$1] "
+ read response
+ if [ -z "$response" ]
+ then
+ response="$1"
+ fi
+ case "$response" in
+ [Nn]*) yesno=no ; return ;;
+ [Yy]*) yesno=yes ; return ;;
+ esac
+ done
+}
+
+getblockdev () {
+ mountpoint="$vardir/methods/mnt"
+ if [ -z "$defaultdevice" ]
+ then
+ defaultdevice="$newdefaultdevice"
+ elif [ "$defaultdevice" != "$newdefaultdevice" ]
+ then
+ echo \
+ "Last time you specified installation from $defaultdevice."
+ fi
+ promptstring="$1"
+ while [ -z "$blockdevice" ]
+ do
+ echo -n "$promptstring [$defaultdevice]: "
+ read response
+ if [ -z "$response" ]
+ then
+ response="$defaultdevice"
+ fi
+ if ! [ -b "$response" ]
+ then
+ echo "$response is not a block device."; continue
+ fi
+ tryblockdevice="$response"
+ if [ $option = cdrom ]
+ then
+ fstype=iso9660
+ elif [ $option = harddisk ]
+ then
+ blockbase="`echo \"$tryblockdevice\" | sed -e 's/[0-9]\{1,\}$//'`"
+ set +e
+ echo -e "p\nq\n" | fdisk "$blockbase" 2>/dev/null >$tp.f
+ set -e
+ proposeddevice="$tryblockdevice" perl -ne '
+next unless /^ *Device +Boot +Begin +Start +End +Blocks +Id +System *$/i .. !/\S/;
+next unless s:^/\S+:: && $& eq $ENV{"proposeddevice"};
+next unless s/^ +(\* +)?\d+ +\d+ +\d+ +\d+\+? +//;
+next unless m/^([0-9a-f]{1,2}) /i;
+%types= ( "1","msdos", "4","msdos", "6","msdos", "7","hpfs", "80","minix",
+ "81","minix", "83","ext2" );
+print $types{$1}; exit(0); ' <$tp.f >$tp.m
+ defaultfstype="`cat $tp.m`"
+ if [ -n "$defaultfstype" ]
+ then
+ cat <<END
+The partition table for $blockbase claims that $tryblockdevice
+contains filesystem type $defaultfstype.
+END
+ if ! grep " $defaultfstype$" /proc/filesystems >/dev/null
+ then
+ echo \
+ "Your kernel does not appear to support that filesystem type."
+ defaultfstype=""
+ fi
+ fi
+ echo -n "Supported filesystems: "
+ sed -e 's/^.* / /' /proc/filesystems | tr '\n' ' '
+ echo -n "
+Enter filesystem type (for $tryblockdevice) [$defaultfstype]: "
+ read fstype
+ if [ -z "$fstype" ]
+ then
+ fstype="$defaultfstype"
+ fi
+ fi
+ umount="$mountpoint"
+ if mount -rt "$fstype" -o nosuid,nodev "$tryblockdevice" "$mountpoint"
+ then
+ echo
+ blockdevice="$tryblockdevice"
+ else
+ umount=""
+ echo \
+ "Unable to mount $tryblockdevice on $mountpoint, type $fstype."
+ fi
+ done
+}
+
+outputparam () {
+ echo "$2" | sed -e "s/'/'\\\\''/; s/^/$1='/; s/$/'/" >&3
+}
+
+intrkey="`stty -a | sed -n 's/.*intr = \([^;]*\);.*/\1/p'`"
+echo "
+If you make a mistake, use the interrupt key ($intrkey) to abort.
+"
+
+# State variables, `best first'
+# {main,ctb,nf,nus,lcl}_{packages,binary}
+# Empty before we've found them or if they're not available,
+# set to the relevant bit under mountpoint otherwise.
+# hierbase
+# A directory containing a Debian FTP site mirror tree for ONE distribution.
+# eg /pub/debian/dists/stable
+# mountpoint
+# The mountpoint for the filesystem containing the stuff
+# empty or unset if we don't know yet, or if we haven't mounted anything;
+# may also be empty if `directory' was set.
+# blockdevice
+# The actual block device to mount.
+# fstype
+# The filesystem type to use.
+# defaultdevice
+# The default block device to mount.
+
+if [ -f shvar.$option ]
+then
+ . ./shvar.$option
+ defaultdevice="$p_blockdev"
+ defaultnfsserver="$p_nfsserver"
+ defaultnfsrempath="$p_nfsrempath"
+fi
+
+if [ $option = cdrom ]
+then
+ mount >$tp.m
+ sed -n 's/ ([^)]*)$//; s/^[^ ]* on //; s/ type iso9660$//p' <$tp.m >$tp.l
+ ncdroms=`wc -l <$tp.l`
+ if [ $ncdroms -gt 1 ]
+ then
+ response=""
+ while [ -z "$response" ]
+ do
+ echo \
+ 'Several CD-ROMs (or other ISO9660 filesystems) are mounted:'
+ grep 'type iso9660 ([^)]*)$' <$tp.m | nl
+ echo -n \
+ 'Is it any of these ? Type a number, or `n'\'' for none. '
+ read response
+ response="`echo \"$response\" | sed -e 's/[ ]*$//'`"
+ if expr "$response" : '[0-9][0-9]*$' >/dev/null && \
+ [ $response -ge 1 ] && [ $response -le $ncdroms ]
+ then
+ mountpoint="`sed -n $response'p' <$tp.l`"
+ echo
+ elif expr "$response" : '[Nn]' >/dev/null
+ then
+ mountpoint=""
+ else
+ response=""
+ fi
+ done
+ elif [ $ncdroms = 1 ]
+ then
+ mountpoint="`cat $tp.l`"
+ perl -ne 'print if s/ type iso9660 \([^)]*\)$// && s/ on .*$//;' \
+ <$tp.m >$tp.d
+ blockdevice="`cat $tp.d`"
+ yesno yes \
+ "I see a CD-ROM: $blockdevice, mounted on $mountpoint. Is it the right one ?"
+ if [ $yesno = no ]
+ then
+ echo 'Unmounting it ...'
+ umount="$mountpoint"
+ while true
+ do
+ echo -n \
+ 'Please insert the right disc, and hit return: '
+ read response
+ if mount -rt iso9660 -o nosuid,nodev \
+ "$blockdevice" "$mountpoint"
+ then
+ echo
+ break
+ fi
+ done
+ fi
+ fi
+ if [ -z "$mountpoint" ]
+ then
+ if [ -b /dev/cdrom ]
+ then
+ echo \
+ 'I see that /dev/cdrom exists and is a block device.'
+ newdefaultdevice=/dev/cdrom
+ fi
+ getblockdev 'Insert the CD-ROM and enter the block device name'
+ fi
+fi
+
+if [ $option = nfs ]
+then
+ mountpoint="$vardir/methods/mnt"
+ while [ -z "$nfsserver" ]
+ do
+ echo -n \
+"What is the name of the NFS server ? [$defaultnfsserver] "
+ read response
+ if [ -z "$response" ] && [ -n "$defaultnfsserver" ]
+ then
+ response="$defaultnfsserver"
+ fi
+ if [ -z "$response" ]; then continue; fi
+ if [ -x /usr/bin/rpcinfo ]
+ then
+ if rpcinfo -u "$response" mountd | grep -q 'ready'
+ then
+ nfsserver="$response"
+ else
+ echo "$response appears not to be an NFS server."
+ fi
+ elif [ -x /bin/ping ]
+ then
+ if ping -q -c 1 "$response" | grep -q ', 1 packets received'
+ then
+ nfsserver="$response"
+ else
+ echo "$response appears to be down or nonexistent."
+ fi
+ else
+ echo \
+"(I can't check that now because there is no /usr/bin/rpcinfo or /bin/ping.)"
+ nfsserver="$response"
+ fi
+ done
+ while [ -z "$nfsrempath" ]
+ do
+ echo -n "
+What is the pathname on the NFS server of the filesystem with
+the Debian files? [$defaultnfsrempath] "
+ read response
+ if [ -z "$response" ] && [ -n "$defaultnfsrempath" ]
+ then
+ response="$defaultnfsrempath"
+ else
+ response="`echo \"$response\" | sed -e 's:/$::; s:^/*:/:'`"
+ fi
+ umount="$mountpoint"
+ if mount -rt nfs -o nosuid,nodev "$nfsserver:$response" "$mountpoint"
+ then
+ echo
+ nfsrempath="$response"
+ else
+ umount=""
+ echo \
+"Unable to mount NFS filesystem $nfsserver:$response."
+ fi
+ done
+ nfs="$nfsserver:$nfsrempath"
+fi
+
+if [ $option = harddisk ]
+then
+ set +e
+ echo -e 'p\nq\n' | fdisk /dev/hda 2>/dev/null >$tp.f
+ if [ $? != 0 ]
+ then
+ echo -e 'p\nq\n' | fdisk /dev/sda 2>/dev/null >$tp.f
+ fi
+ set -e
+ perl -ne '
+next unless /^ *Device +Boot +Begin +Start +End +Blocks +Id +System *$/i .. !/\S/;
+next unless / [146] +DOS \d+-bit \S+$/;
+next unless m:^/\S+:;
+print $&; ' <$tp.f >$tp.d
+ newdefaultdevice="`cat $tp.d`"
+ echo "
+I need to know which disk partition contains the distribution files;
+disk partitions are specified by the block device name in Linux."
+ if [ -n "$newdefaultdevice" ]
+ then
+ echo \
+"By the way, $newdefaultdevice looks like a DOS partition."
+ fi
+ getblockdev "Enter the partition's block device name"
+fi
+
+if [ -n "$mountpoint" ]
+then
+ # We must have $mountpoint
+ if [ $option = cdrom ]
+ then
+ echo \
+'All directory names should be entered relative to the root of the CD-ROM.
+'
+ elif [ $option = nfs ]
+ then
+ echo \
+"All directory names should be entered relative to the root of the NFS
+filesystem, ie relative to $nfsrempath on the server.
+"
+ else
+ echo \
+"All directory names should be entered relative to the root of the
+$fstype filesystem on $blockdevice.
+"
+ fi
+fi
+
+while true
+do
+ if [ $option = cdrom ]
+ then
+ echo \
+"I would like to know where on the CD-ROM the top level of the Debian
+distribution is (eg. 'dists/stable') - this directory usually contains the
+Packages-Master file.
+
+If the CD-ROM is badly organised and doesn't have a straightforward copy of
+the distribution you may answer \`none' and we'll go through the parts
+I need individually."
+ else
+ echo \
+"In order to make it easy for me to find the relevant files I'd ideally
+like to install from a straightforward copy of the Debian distribution.
+To use this I'll need to know where the top level of that copy of the
+distribution is (eg. 'debian/dists/stable') - this directory usually
+contains the Packages-Master file.
+
+If you do not have a straightforward copy of the distribution available
+just answer \`none' and we'll go through the parts I need individually."
+ fi
+ defhierbase=none
+# maybe ask for debian/dists and then show and ask for available dists
+# eg. {stable,frozen,unstable,bo,hamm,slink}
+ if [ -n "$p_hierbase" ]
+ then
+ if [ -d "$mountpoint/$p_hierbase/main/binary-$iarch" ]
+ then
+ echo "
+Last time you said \`$p_hierbase', and that looks plausible."
+ defhierbase="$p_hierbase"
+ else
+ echo "
+Last time you said \`$p_hierbase', but that doesn't look plausible,
+since \`$p_hierbase/main/binary-$iarch' doesn't seem to exist."
+ fi
+ fi
+ if [ none = "$defhierbase" ]
+ then
+ if [ -d "$mountpoint/debian/dists/stable/main/binary-$iarch" ]
+ then
+ echo "
+\`/debian/dists/stable' exists and looks plausible, so that's the default."
+ defhierbase=/debian/dists/stable
+ elif [ -d "$mountpoint/dists/stable/main/binary-$iarch" ]
+ then
+ echo "
+\`/dists/stable' exists and looks plausible, so that's the default."
+ defhierbase=/dists/stable
+ fi
+ fi
+ echo -n \
+"Distribution top level ? [$defhierbase] "
+ read response
+ if [ -z "$response" ]
+ then
+ response="$defhierbase"
+ fi
+ if [ none = "$response" ]
+ then
+ hierbase=""
+ break
+ elif [ -d "$mountpoint/$response/main/binary-$iarch" ]
+ then
+ hierbase="`echo \"$response\" | sed -e 's:/*$::; s:^/*:/:'`"
+ break
+ fi
+ echo \
+"$response/main/binary-$iarch does not exist.
+"
+done
+
+
+case "$hierbase" in
+/* ) ;;
+'' ) ;;
+* ) hierbase="/$hierbase" ;;
+esac
+
+check_binary () {
+ # args: area-in-messages directory
+ # eg: main "$hierbase/main/binary-$iarch"
+ # checks wether $2 contains *.deb
+ if ! [ -d "$mountpoint$2/" ]
+ then
+ echo "\`$2' does not exist."
+ return
+ fi
+
+ if ! ( find "$mountpoint$2/" -follow -name '*.deb' -print \
+ | head -n 1 ) 2>/dev/null | grep . >/dev/null
+ then
+ echo "\`$2' does not contain any *.deb packages. Hmmpf."
+ return
+ fi
+ echo "Using \`$2' as $1 binary dir."
+ this_binary="$2"
+}
+
+find_area () {
+ # args: area-in-messages area-in-vars subdirectory-in-hier
+ # last-time-binary last-time-packages
+ # eg: main main main
+ # "$p_main_binary" "$p_main_packages"
+
+ this_binary=''
+ this_packages=''
+ if [ -n "$hierbase" ]
+ then
+ check_binary $1 "$hierbase/$3/binary-$iarch"
+ fi
+
+ if [ $option = cdrom ] && [ $2 = nf ] && [ -z "$this_binary" ]
+ then
+ echo '
+Note: most CD-ROM distributions of Debian do not include programs
+available in the `non-free'\'' directory of the distribution site.
+This is because these programs have copyrights that prevent
+distribution for profit on a CD-ROM - ie they are not free software.
+If you wish to install these programs you'\''ll have to get them from an
+alternative source.'
+ elif [ $2 = lcl ] && [ -z "$this_binary" ]
+ then
+ echo '
+Note: By default there is no `local'\'' directory. It is intended for
+packages you made yourself.'
+ fi
+ while [ -z "$this_binary" ]
+ do
+ defaultbinary="$4"
+ echo "
+Which directory contains the *.deb packages from the $1 distribution
+area (this directory is named \`$3/binary-$iarch' on the distribution site) ?
+Say \`none' if this area is not available."
+ if [ $2 != main ] && [ -z "$defaultbinary" ]
+ then
+ defaultbinary=none
+ fi
+ echo -n \
+"Enter _$1_ binary dir. [$4]
+ ? "
+ read response
+ if [ -z "$response" ] && [ -n "$defaultbinary" ]
+ then
+ response="$defaultbinary"
+ fi
+ if [ none = "$response" ]
+ then
+ break
+ fi
+ case "$response" in
+ '' | none) continue ;;
+ esac
+ check_binary $1 "`echo \"$response\" | sed -e 's:/$::; s:^/*:/:'`"
+ done
+ if [ -n "$this_binary" ]
+ then
+ for f in Packages.gz packages.gz Packages packages
+ do
+ if [ -f "$mountpoint/$this_binary/$f" ]
+ then
+ echo "Using \`$this_binary/$f' for $1."
+ this_packages="$this_binary/$f"
+ break
+ fi
+ done
+ while [ -z "$this_packages" ]
+ do
+ echo -n "
+I can't find the $1 \`Packages' file. The information in the
+\`Packages' file is important for package selection during new
+installations, and is very useful for upgrades.
+
+If you overlooked it when downloading you should do get it now and
+return to this installation procedure when you have done so: you will
+find one Packages file and one Packages.gz file -- either will do --
+in the \`binary-$iarch' subdirectory of each area on the FTP sites and
+CD-ROMs. Alternatively (and this will be rather slow) I can scan the
+packages in the distribution area - say \`scan' if you want me to do so.
+
+You need a separate Packages file from each of the distribution areas
+you wish to install.
+
+Where is the _$1_ \`Packages' file (if none is available, say \`none')
+[$5]
+ ? "
+ read response
+ if [ -z "$response" ] && [ -n "$5" ]
+ then
+ response="$5"
+ fi
+ case "$response" in
+ '') continue ;;
+ none) break ;;
+ scan) this_packages=scan ;;
+ /*) this_packages="$response" ;;
+ *) this_packages="/$response" ;;
+ esac
+ done
+ fi
+ eval $2'_binary="$this_binary"'
+ eval $2'_packages="$this_packages"'
+}
+
+find_area main main main "$p_main_binary" "$p_main_packages"
+find_area contrib ctb contrib "$p_ctb_binary" "$p_ctb_packages"
+find_area non-free nf non-free "$p_nf_binary" "$p_nf_packages"
+find_area non-US nus non-US "$p_nus_binary" "$p_nus_packages"
+find_area local lcl local "$p_lcl_binary" "$p_lcl_packages"
+
+echo -n '
+Hit RETURN to continue. '
+read response
+
+exec 3>shvar.$option.new
+
+outputparam p_blockdev "$blockdevice"
+outputparam p_fstype "$fstype"
+outputparam p_mountpoint "$mountpoint"
+outputparam p_nfsserver "$nfsserver"
+outputparam p_nfsrempath "$nfsrempath"
+outputparam p_nfs "$nfs"
+outputparam p_hierbase "$hierbase"
+
+outputparam p_main_packages "$main_packages"
+outputparam p_main_binary "$main_binary"
+outputparam p_ctb_packages "$ctb_packages"
+outputparam p_ctb_binary "$ctb_binary"
+outputparam p_nf_packages "$nf_packages"
+outputparam p_nf_binary "$nf_binary"
+outputparam p_nus_packages "$nus_packages"
+outputparam p_nus_binary "$nus_binary"
+outputparam p_lcl_packages "$lcl_packages"
+outputparam p_lcl_binary "$lcl_binary"
+
+mv shvar.$option.new shvar.$option
+
+xit=0
+
+
diff --git a/dselect/methods/disk/update b/dselect/methods/disk/update
new file mode 100755
index 000000000..9d917230a
--- /dev/null
+++ b/dselect/methods/disk/update
@@ -0,0 +1,92 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/disk"
+
+. ./shvar.$option
+
+if [ -z "$p_main_packages" ] && [ -z "$p_ctb_packages" ] && \
+ [ -z "$p_nf_packages" ] && [ -z "$p_nus_packages " ] && \
+ [ -z "$p_lcl_packages" ]
+then
+ echo '
+No Packages files available, cannot update available packages list.
+Hit RETURN to continue. '
+ read response
+ exit 0
+fi
+
+xit=1
+trap '
+ rm -f packages-main packages-ctb packages-nf packages-nus packages-lcl
+ if [ -n "$umount" ]
+ then
+ umount "$umount" >/dev/null 2>&1
+ fi
+ exit $xit
+' 0
+
+if [ -n "$p_blockdev" ]
+then
+ umount="$p_mountpoint"
+ mount -rt "$p_fstype" -o nosuid,nodev "$p_blockdev" "$p_mountpoint"
+fi
+
+if [ -n "$p_nfs" ]
+then
+ umount="$p_mountpoint"
+ mount -rt nfs "$p_nfs" -o nosuid,nodev "$p_mountpoint"
+fi
+
+updatetype=update
+
+for f in main ctb nf nus lcl
+do
+ eval 'this_packages=$p_'$f'_packages'
+ case "$this_packages" in
+ '')
+ continue
+ ;;
+ scan)
+ eval 'this_binary=$p_'$f'_binary'
+ if [ -z "$this_binary" ]; then continue; fi
+ if [ "$updatetype" = update ]
+ then
+ dpkg --admindir $vardir --clear-avail
+ updatetype=merge
+ fi
+ echo Running dpkg --record-avail -R "$p_mountpoint$this_binary"
+ dpkg --admindir $vardir --record-avail -R "$p_mountpoint$this_binary"
+ ;;
+ *)
+ packagesfile="$p_mountpoint$this_packages"
+ case "$packagesfile" in
+ *.gz | *.Z | *.GZ | *.z)
+ echo -n "Uncompressing $packagesfile ... "
+ zcat <"$packagesfile" >packages-$f
+ echo done.
+ dpkg --admindir $vardir --$updatetype-avail packages-$f
+ updatetype=merge
+ ;;
+ '')
+ ;;
+ *)
+ dpkg --admindir $vardir --$updatetype-avail "$packagesfile"
+ updatetype=merge
+ ;;
+ esac
+ ;;
+ esac
+done
+
+dpkg --forget-old-unavail
+
+echo -n 'Update OK. Hit RETURN. '
+read response
+
+xit=0
+
diff --git a/dselect/methods/floppy/desc.floppy b/dselect/methods/floppy/desc.floppy
new file mode 100644
index 000000000..0bd6329ed
--- /dev/null
+++ b/dselect/methods/floppy/desc.floppy
@@ -0,0 +1,9 @@
+Installation using a pile of floppies, at least one of which (usually
+the first) contains the Packages file, and the rest of which contain
+the binary *.deb files.
+
+If you are installing software from the `non-free' or `contrib'
+directories as well as the main Debian distribution you must have the
+Packages files for those areas on separate floppies. The usual way to
+do this is to put each Packages file on the first floppy which contains
+packages from the relevant area.
diff --git a/dselect/methods/floppy/install b/dselect/methods/floppy/install
new file mode 100755
index 000000000..51224c34d
--- /dev/null
+++ b/dselect/methods/floppy/install
@@ -0,0 +1,100 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/floppy"
+
+mountpoint="$vardir/methods/mnt"
+
+. ./shvar.$option
+
+help () {
+ echo '
+Now I need the disks containing the packages to be installed.
+I shall keep telling you what is left to be done, in case that
+is helpful deciding which floppy to use.'
+}
+
+help
+
+xit=1
+trap '
+ if [ -n "$umount" ]
+ then
+ umount "$umount"
+ fi
+ exit $xit
+' 0
+
+while [ -z "$goconfigure" ]
+do
+ yet="`dpkg --admindir $vardir --yet-to-unpack`"
+ if [ -z "$yet" ]
+ then
+ echo '
+All packages unpacked, going on to configure them.
+'
+ goconfigure=1
+ continue
+ fi
+ echo '
+Packages yet to be unpacked:'
+ echo "$yet"
+ dpkg-split -l
+
+ echo -n '
+Insert a disk containing *.deb files, or type q to quit. '
+ read response
+ case "$response" in
+ [Qq] | [Qq][Uu][Ii][Tt] )
+ goconfigure=1
+ ;;
+ * )
+ umount="$defaultfloppy"
+ if mount -rt "$defaultfstype" "$defaultfloppy" "$mountpoint"
+ then
+ echo
+ dpkg --admindir $vardir --unpack -GROEB "$mountpoint" || true
+ umount "$defaultfloppy"
+ fi
+ umount=""
+ ;;
+ esac
+done
+
+if ! [ -z "$yet" ]
+then
+ response=""
+ while [ -z "$response" ]
+ do
+ echo -n '
+Not all the packages have yet been unpacked. Shall I try to
+proceed with configuration anyay ? If any of the packages which
+have been unpacked so far depend on any that haven'\''t then you'\''ll
+see error messages; on the other hand if you say no those packages that
+could have been configured will not be. (y/n) '
+ read response
+ case "$response" in
+ [Nn]* )
+ echo '
+OK. Be sure to come back to this, because unpacked-but-not-configured
+packages are not in general useable. Alternatively, use the Configure
+option on the dselect menu.
+'
+ exit 1
+ ;;
+ [Yy]* )
+ ;;
+ * )
+ response=""
+ ;;
+ esac
+ done
+fi
+
+dpkg --admindir $vardir --configure --pending
+
+xit=0
diff --git a/dselect/methods/floppy/names b/dselect/methods/floppy/names
new file mode 100644
index 000000000..72b189a1c
--- /dev/null
+++ b/dselect/methods/floppy/names
@@ -0,0 +1 @@
+50 floppy Install from a pile of floppy disks.
diff --git a/dselect/methods/floppy/setup b/dselect/methods/floppy/setup
new file mode 100755
index 000000000..8c16cd233
--- /dev/null
+++ b/dselect/methods/floppy/setup
@@ -0,0 +1,76 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/floppy"
+
+defaultfloppy=fd0
+defaultfstype=msdos
+if [ -f shvar.$option ]
+then
+ . ./shvar.$option
+ defaultfloppy="`echo \"$defaultfloppy\" | sed -e 's,^/dev/,,'`"
+fi
+
+while [ -z "$floppy" ]
+do
+ echo -n '
+Which floppy disk drive do you wish to use ? Give the name in
+/dev (eg fd0) or the MSDOS drive letter (eg A). ['$defaultfloppy'] '
+ read floppy
+ if [ -z "$floppy" ]
+ then
+ floppy="$defaultfloppy"
+ fi
+ case "$floppy" in
+ [ABab] | [ABab]: )
+ floppy="`echo $floppy | \
+ sed -e 's/:$//; s,^[Aa],/dev/fd0,; s,^[Bb],/dev/fd1,'`"
+ ;;
+ /* )
+ ;;
+ * )
+ floppy="/dev/$floppy"
+ ;;
+ esac
+ if ! [ -b "$floppy" ]
+ then
+ echo "$floppy is not a block device."
+ floppy=""
+ fi
+done
+
+while [ -z "$fstype" ]
+do
+ echo -n '
+What kind of filesystem is on the floppies ? ['$defaultfstype'] '
+ read fstype
+ if [ -z "$fstype" ]
+ then
+ fstype="$defaultfstype"
+ fi
+ if ! grep " $fstype$" /proc/filesystems >/dev/null
+ then
+ echo \
+ "Your kernel does not appear to support that filesystem type."
+ fstype=""
+ fi
+done
+
+echo
+
+outputparam () {
+ echo "$2" | sed -e "s/'/'\\\\''/; s/^/$1='/; s/$/'/" >&3
+}
+
+exec 3>shvar.$option.new
+
+outputparam defaultfloppy "$floppy"
+outputparam defaultfstype "$fstype"
+
+mv shvar.$option.new shvar.$option
+
+exit 0
diff --git a/dselect/methods/floppy/update b/dselect/methods/floppy/update
new file mode 100755
index 000000000..3d79731cd
--- /dev/null
+++ b/dselect/methods/floppy/update
@@ -0,0 +1,76 @@
+#!/bin/sh
+
+set -e
+vardir="$1"
+method=$2
+option=$3
+
+cd "$vardir/methods/floppy"
+
+mountpoint="$vardir/methods/mnt"
+
+. ./shvar.$option
+
+help () {
+ echo '
+First I need the disk(s) which contain the Packages file(s) for
+the parts of the archive you wish to be able to install. If you
+want to install packages from the non-free and contrib areas of
+the FTP site you need a floppy with a Packages file for each of
+those, in addition to the main Packages file for the main Debian
+distribution. If you don'\''t then you just need one Packages file.'
+}
+
+help
+
+xit=1
+trap '
+ if [ -n "$umount" ]
+ then
+ umount "$umount"
+ fi
+ exit $xit
+' 0
+
+tryupdate () {
+ if [ $success = 1 ]; then return; fi
+ if [ ! -f "$mountpoint/Packages" ]; then
+ echo "$mountpoint/Packages does not exist.";
+ return
+ fi
+ if dpkg --admindir $vardir --merge-avail "$mountpoint/Packages"
+ then
+ success=1
+ echo '
+You may incorporate another Packages file from another floppy if you wish.'
+ fi
+}
+
+while [ $xit = 1 ]
+do
+ echo -n '
+Insert a disk containing a Packages file, or type q to quit. '
+ read response
+ case "$response" in
+ [Qq] | [Qq][Uu][Ii][Tt] )
+ xit=0
+ ;;
+ * )
+ umount="$defaultfloppy"
+ if mount -rt "$defaultfstype" "$defaultfloppy" "$mountpoint"
+ then
+ success=0
+ tryupdate Packages
+ tryupdate packages
+ tryupdate PACKAGES
+ umount "$defaultfloppy"
+ fi
+ umount=""
+ ;;
+ esac
+done
+
+echo '
+OK, continuting with installation.'
+
+xit=0